#!/usr/bin/env python
#
# LpBugReporter - A Linux Xtremsplit file tool
#
# Copyright (C) zedtux <zedtux@zedroot.org>
#
# LpBugReporter is free software; you can redistribute it and/or modify
# it under the terms of the GNU General Public License as published by
# the Free Software Foundation; either version 3 of the License, or
# (at your option) any later version.
#
# LpBugReporter is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
# GNU General Public License for more details.
#
# You should have received a copy of the GNU General Public License
# along with LpBugReporter; if not, write to the Free Software Foundation, Inc.,
# 51 Franklin Street, Fifth Floor, Boston, MA 02110-1301, USA

import os
import sys
import glob

from setuptools import setup, find_packages

def execcmd(cmd):
    print "Executing %s..." % cmd
    result = os.system(cmd)
    if result == 0:
        print "Executed successfully"
    else:
        print "Error: Execution failed !"

def extract_version():
    if not os.path.exists("VERSION"):
        execcmd("make version")
    
    if os.path.exists("VERSION"):
        f = open("VERSION")
        version = f.read()[0:-1]
        f.close()
        return version
    else:
        print "ERROR: Unable to read the VERSION file."

def fix_args():
    """
    Add if missing '--record' param
    """
    record_found = False
    for arg in sys.argv:
        if arg == "--record":
            record_found = True
            break
    if not record_found:
        sys.argv.append("--record")
        sys.argv.append("uninstall.list")

if __name__ == '__main__':
    #-----------------------------------------
    # Hacked setup.py
    #
    # This hacked version provide an uninstall
    # role that standard setup.py miss.
    #-----------------------------------------
    if len(sys.argv) == 1:
        print "error: no commands supplied"
    
    elif sys.argv[1] == "uninstall":
        print "Uninstalling..."
        if os.path.exists("uninstall.list"):
            
            # Remove all installed files
            execcmd("cat uninstall.list | xargs rm -rf")
        
        else:
            print
            print "Error: I can't find the file uninstall.list."
            print "Please, execute again 'python setup.py install', then restart 'python setup.py uninstall'"
    
    else:
        
        if sys.argv[1] == "install":
            fix_args()
        version = extract_version()
        
        if not version == "":
            print "Version : '%s'" % version
            
            setup(name='lpbugreporter',
                  version=version,
                  description='A Bug reporter module for your hosted Launchpad project.',
                  author='zedtux',
                  author_email='zedtux@zedroot.org',
                  url='https://launchpad.net/lpbugreporter/',
                  keywords=['launchpad','python', 'bug'],
                  license='GNU GPLv3',
                  platforms='linux',
                  package_dir={'': 'src'},
                  packages=['', 'bugreporter'],
                  include_package_data=True)
            
            print
            print "Installation finished !"
            print
